
#include "avej_util_font12x12.h"

CSmFont12x12::CSmFont12x12(void)
{
}

CSmFont12x12::~CSmFont12x12(void)
{
}

bool CSmFont12x12::RenderText(int xDest, int yDest, const MCHAR* szText, unsigned long color, TBltParam rect[], int nRect)
{
	enum
	{
		ASCII_LEFT    = 6,
		ASCII_TOP     = 20,
		ASCII_WIDTH   = 6,
		ASCII_HEIGHT  = 12,

		HANGUL_LEFT   = 0,
		HANGUL_TOP    = 32,
		HANGUL_WIDTH  = 12,
		HANGUL_HEIGHT = 12,
		HANGUL_PITCH  = int(1024 / HANGUL_WIDTH),
	};

	const TBltParam blankParam =
	{
		true, 0, 0,
		0, ASCII_TOP, HANGUL_WIDTH, HANGUL_HEIGHT,
		0
	};

	int code;
	int index = 0;

	while ((code = (unsigned char)(*szText++)))
	{
		// ѱ ڵ  ڸ ȮѴ.
		if (code & 0x80)
		{
			if (*szText == 0)
				break;

			code <<= 8;
			code  |= (unsigned char)(*szText++);
		}

		if (--nRect < 0)
			break;

		if (code <= 0x00FF)
		{
			if (code < 0x20 || code > 0x7F)
				code = 0x20;
			code -= 0x20;

			rect[index].isAvailable = true;
			rect[index].xDest = xDest;
			rect[index].yDest = yDest;
			rect[index].x1    = code * ASCII_WIDTH + ASCII_LEFT;
			rect[index].y1    = ASCII_TOP;
			rect[index].x2    = rect[index].x1 + ASCII_WIDTH;
			rect[index].y2    = rect[index].y1 + ASCII_HEIGHT;

			xDest += ASCII_WIDTH;
		}
		else
		{
			int ixGlyph = -1;

			if ((code >= 0xA4A1) && (code <= 0xA4D3))
			{
				ixGlyph = code - 0xA4A1;
			}
			else if ((code >= 0xB0A1) && (code <= 0xC8FE))
			{
				int sm1, sm2;
				sm1 = (code >> 8 ) & 0xFF;
				sm2 = (code & 0xFF );

				sm1 = sm1 - 0xB0;
				sm2 = sm2 - 0xA1;

				if ((sm2 >= 0) && (sm2 < 94))
					ixGlyph = sm1 * 94 + sm2 + 51;
			}

			if (ixGlyph >= 0)
			{
				rect[index].isAvailable = true;
				rect[index].xDest = xDest;
				rect[index].yDest = yDest;
				rect[index].x1    = (ixGlyph % HANGUL_PITCH) * HANGUL_WIDTH + HANGUL_LEFT;
				rect[index].y1    = (ixGlyph / HANGUL_PITCH) * HANGUL_HEIGHT + HANGUL_TOP;
				rect[index].x2    = rect[index].x1 + HANGUL_WIDTH;
				rect[index].y2    = rect[index].y1 + HANGUL_HEIGHT;
			}
			else
			{
				rect[index]       = blankParam;
				rect[index].xDest = xDest;
				rect[index].yDest = yDest;
			}

			xDest += HANGUL_WIDTH;
		}

		rect[index].color = color;

		++index;
	}

	if (nRect >= 0)
		rect[index].isAvailable = false;

	return true;
}
