
////////////////////////////////////////////////////////////////////////////////
// uses

#include "pdm_res.h"
#include "pdm_config.h"

#include "avej_util_font12x12.h"
#include "flat_experience.h"
#include "sm_util.h"

#include <stdio.h>

flat_experience::ICanvas*      g_canvas       = NULL;
flat_experience::IInputDevice* p_input_device = NULL;

//////////////////

#define HANDLE_KEYEVENT(KM,ACTION)  \
	if ( KeyMap2[KM] ) { ACTION; }
#define HANDLE_KEYEVENT2(KM,ACTION)  \
	if ( KeyMap1[KM] ) { KeyMap1[KM] = 0; ACTION; }

//////////////////

void s_DrawText(int x, int y, const char* szText)
{
	CSmFont12x12 s_font;
	CSmFont12x12::TBltParam rect[20];
	if (s_font.RenderText(x, y, szText, 0xF800, rect, 20))
	{
		for (int i = 0; i < 20; i++)
		{
			if (!rect[i].isAvailable)
				break;

			g_canvas->BitBlt(rect[i].xDest, rect[i].yDest, g_p_pdm_res->GetImage(CPdmRes::IMAGE_FONT), rect[i].x1, rect[i].y1, rect[i].x2 - rect[i].x1, rect[i].y2 - rect[i].y1);
		}
	}
}

static void s_DisplayFPS()
{
#if defined(USE_FPS_DISPLAYING)

	static long  s_count = 0;
	static long  s_sTick = 0;
	static long  s_eTick = 0;
	static MCHAR s_szFPS[256] = {0, };
	static bool  s_tinkle = true;

	++s_count;

	if (s_sTick > 0)
	{
		s_eTick = flat_experience::system::GetTicks();

		// 30 FPS frame skipping
		{
			static long  s_prev_tick = 0;

			while (s_eTick - s_prev_tick < 30)
				s_eTick = flat_experience::system::GetTicks();

			s_prev_tick = s_eTick;
		}

		if (s_eTick - s_sTick > 1000)
		{
			SPRINTF(s_szFPS, sizeof(s_szFPS), "FPS: %ld", s_count);

			s_tinkle = !s_tinkle;
			if (s_tinkle)
				s_szFPS[3] = ' ';
			
			s_count = 0;
			s_sTick = flat_experience::system::GetTicks();
		}
		s_DrawText(10, 10, s_szFPS);
	}
	else
	{
		s_sTick = flat_experience::system::GetTicks();
	}
#endif // USE_FPS_DISPLAYING
}

bool OnCreate(void)
{
	// ؽ ̹ б
	{
		g_p_pdm_res->m_ixImage[CPdmRes::IMAGE_TILE  ] = sm_util::CreateCanvasFromPNG(PIXELFORMAT_RGB565, "deja512_1.png");
		g_p_pdm_res->m_ixImage[CPdmRes::IMAGE_CHARA ] = sm_util::CreateCanvasFromPNG(PIXELFORMAT_RGB565, "deja512_2.png", 0x0000);
		g_p_pdm_res->m_ixImage[CPdmRes::IMAGE_WINDOW] = NULL;
		g_p_pdm_res->m_ixImage[CPdmRes::IMAGE_FONT  ] = sm_util::CreateCanvasFromPNG(PIXELFORMAT_RGB565, "font1bit_1024_512.png", 0x0000);
	}

	//  б
	{
		g_p_pdm_res->pTileMap = new CTileMap();
		g_p_pdm_res->pTileMap->LoadFromFile_Dejavu("Roperr.maf");

		for (int y = 0; y < g_p_pdm_res->pTileMap->Height(); y++)
		{
			for (int x = 0; x < g_p_pdm_res->pTileMap->Width(); x++)
			{
				int index = g_p_pdm_res->pTileMap->Map(x, y)->data.character;
				ISorakChara::TCharaDesc charDesc;

				if (index > 0)
				{
					// id, face, face dir, type
					int* pUserParams = g_p_pdm_res->pTileMap->UserParameter(index);

					g_p_pdm_res->pChara[index] = new CSorakChara();

					memset(&charDesc, 0, sizeof(charDesc));
					charDesc.id = index;
					charDesc.x = x;
					charDesc.y = y;
					charDesc.face = pUserParams[1];
					charDesc.type = pUserParams[4];
					charDesc.equipment[0] = 5*12-1;
					charDesc.equipment[1] = 5*12+7;
					charDesc.equipment[2] = 1*12+1;
					charDesc.equipment[3] = 4*12+7;
					charDesc.equipment[4] = 7*12+9;
					charDesc.equipment[5] = 7*12+11;
					charDesc.backPack[0] = 5*12-1;
					charDesc.backPack[1] = 5*12+7;
					charDesc.backPack[2] = 1*12+1;
					charDesc.backPack[3] = 4*12+7;
					charDesc.backPack[4] = 7*12+9;
					charDesc.backPack[5] = 7*12+11;
					charDesc.backPack[6] = 8*12+1;
					charDesc.backPack[7] = 8*12+2;
					charDesc.backPack[8] = 8*12+3;
					charDesc.backPack[9] = 8*12+4;

					if (index == 2)
					{
						strncpy(charDesc.szName, "", sizeof(charDesc.szName));
					}
					charDesc.face = (index-1)*3;

					g_p_pdm_res->pChara[index]->Init(charDesc);
				}
			}
		}
	}

	//  ĳͰ  ʴ ̸ Ʈ ĳ   
	{
		if (g_p_pdm_res->pChara[MAIN_CHARACTER] == NULL)
		{
			ISorakChara::TCharaDesc charDesc;

			g_p_pdm_res->pChara[MAIN_CHARACTER] = new CSorakChara();

			memset(&charDesc, 0, sizeof(charDesc));
			charDesc.id = MAIN_CHARACTER;
			charDesc.x = 10;
			charDesc.y = 1;
			charDesc.face = 0;
			charDesc.type = 0;

			g_p_pdm_res->pChara[MAIN_CHARACTER]->Init(charDesc);
		}
	}

	//  
	{
		g_p_pdm_res->pWindow[0] = CSorakWindow::Create(CSorakWindow::WINDOW_TYPE_MAP, 0, -10, g_p_pdm_res->pChara[MAIN_CHARACTER]);
	}

	// 쿡 Ŀ ֱ
	g_p_pdm_res->pWindow[0]->OnFocus(true);

	return true;
}

bool OnDestory(void)
{
	//??   ϱ

	delete g_p_pdm_res->m_ixImage[CPdmRes::IMAGE_TILE  ];
	delete g_p_pdm_res->m_ixImage[CPdmRes::IMAGE_CHARA ];
	delete g_p_pdm_res->m_ixImage[CPdmRes::IMAGE_WINDOW];
	delete g_p_pdm_res->m_ixImage[CPdmRes::IMAGE_FONT  ];

	return true;
}

bool OnProcess(void)
{
	g_canvas->BeginDraw();
	{
		g_canvas->FillRect(0, 0, 320, 240, 0x0000);

		// display windows
		for (int i = MAX_AVEJ_WINDOW-1; i >= 0; i--)
		{
			if (g_p_pdm_res->pWindow[i])
			{
				int xMap = 65, yMap = 27;
				g_p_pdm_res->pWindow[i]->Update(xMap, yMap);
			}
		}

		s_DisplayFPS();
	}
	g_canvas->EndDraw();

#if defined(_WIN32)
//	AvejUtil::Delay(18);
#endif

	return true;
}

void deja_init()
{
	flat_experience::Initialize(flat_experience::SCREENROTATON_CCW90);

	g_canvas = flat_experience::GetCanvas(1);
	p_input_device = flat_experience::GetInputDevice();

	OnCreate();
}

bool deja_process()
{
	const flat_experience::TInputUpdateInfo& update_info = p_input_device->Update();

	if (p_input_device->CheckKeyPressed(flat_experience::KEY_MENU))
		return false;

	if (p_input_device->CheckKeyPressed(flat_experience::KEY_UP))
		g_p_pdm_res->pWindow[0]->OnKeyDown(0, flat_experience::KEY_UP);
	if (p_input_device->CheckKeyPressed(flat_experience::KEY_DOWN))
		g_p_pdm_res->pWindow[0]->OnKeyDown(0, flat_experience::KEY_DOWN);
	if (p_input_device->CheckKeyPressed(flat_experience::KEY_LEFT))
		g_p_pdm_res->pWindow[0]->OnKeyDown(0, flat_experience::KEY_LEFT);
	if (p_input_device->CheckKeyPressed(flat_experience::KEY_RIGHT))
		g_p_pdm_res->pWindow[0]->OnKeyDown(0, flat_experience::KEY_RIGHT);

	return OnProcess();
}

void deja_done()
{
	OnDestory();

	delete p_input_device;

	//??ĵ ?

	flat_experience::Finalize();
}


int _main()
{
	deja_init();

	while (deja_process())
		;

	deja_done();

	return 0;
}

#if defined(_MSC_VER) || (TARGET_DEVICE == TARGET_GP2XWIZ)
int main(int argc, char* argv[])
{
	return _main();
}
#endif
