
#include "pdm_window.h"
#include "pdm_config.h"

#include <assert.h>

enum
{
	MARGIN_L =  0,
	MARGIN_R =  0,
	MARGIN_T =  0,
	MARGIN_B =  0,
	WINDOW_W = (TILE_WSIZE * WORLDMAP_WSIZE),
	WINDOW_H = (TILE_HSIZE * WORLDMAP_HSIZE),
};

const TRect& CSorakWindow::m_GetClientRect(void)
{
	m_clientRect.x1 = m_x;
	m_clientRect.y1 = m_y;
	m_clientRect.x2 = m_x + WINDOW_W;
	m_clientRect.y2 = m_y + WINDOW_H;

	return m_clientRect;
}

const TRect& CSorakWindow::m_GetWindowRect(void)
{
	m_windowRect.x1 = m_x - MARGIN_L;
	m_windowRect.y1 = m_y - MARGIN_T;
	m_windowRect.x2 = m_x + WINDOW_W + MARGIN_R;
	m_windowRect.y2 = m_y + WINDOW_H + MARGIN_B;

	return m_windowRect;
}

int  CSorakWindow::m_InRegion(int x, int y)
{
	TRect rect = m_GetWindowRect();
	return ((x >= rect.x1) && (x < rect.x2) && (y >= rect.y1) && (y < rect.y2)) ? 1 : 0;
}

bool CSorakWindow::m_Display(long xMap, long yMap)
{
/*
	IGfxDevice*  pGfxDevice = IGfxDevice::GetInstance();
	IGfxSurface* pBackBuffer;
	pGfxDevice->GetSurface(&pBackBuffer);

	pBackBuffer->BitBlt(m_x-MARGIN_L, m_y-MARGIN_T, (IGfxSurface*)pAvejMain->GetImage(2), 0, 0, WINDOW_W+MARGIN_L+MARGIN_R, WINDOW_H+MARGIN_T+MARGIN_B);

	pGfxDevice->Release();
*/
	return true;
}

void CSorakWindow::m_OnMouseDown(EMouseButton button, int shift, int x, int y)
{
	m_isPressed = true;
	m_xPressed  = x;
	m_yPressed  = y;
}

void CSorakWindow::m_OnMouseUp(EMouseButton button, int shift, int x, int y)
{
	m_isPressed = false;
}

void CSorakWindow::m_OnMouseMove(int shift, int x, int y)
{
	m_x += (x - m_xPressed);
	m_y += (y - m_yPressed);
}

void CSorakWindow::m_OnKeyDown(int shift, int key)
{
}

void CSorakWindow::m_OnKeyUp(int shift, int key)
{
}

void CSorakWindow::m_OnKeyChar(char ch)
{
}

void CSorakWindow::m_OnFocus(bool isFocused)
{
	m_isFocused = isFocused;
}

#include "pdm_window_map.h"

CSorakWindow* CSorakWindow::Create(EWindowType type, long x, long y, void* pParam1, void* pParam2)
{
	CSorakWindow* pWindow = NULL;

	switch (type)
	{
	case WINDOW_TYPE_MAP:
		pWindow = new CSorakWindowMap(x, y, (ISorakChara*)pParam1);
		break;
	default:
		assert(false);
	}
	
	return pWindow;
}
