
#include <assert.h>
#include <stdlib.h>

#include "pdm_window_map.h"
#include "pdm_res.h"
#include "pdm_config.h"

#include "avej_util_pascal_set.h"
#include "avej_util_tile_map.h"

#include "flat_experience.h"

extern void s_DrawText(int x, int y, const char* szText);

extern flat_experience::ICanvas* g_canvas;

#define MaxPoints 50

#define Mini(a, b) ((a) < (b)) ? (a) : (b)
#define Maxi(a, b) ((a) > (b)) ? (a) : (b)

void FilledPolygon(int NumPoints,int Pointsx[],int Pointsy[], void (*DrawHLine)(int x, int y, int w))
{
	struct all_edges
	{
		int   ymin;
		int   ymax;
		float x;
		float m;
	} *Edges[MaxPoints];

	if (NumPoints > 0)
	{
		int i,succ;
		for (i = 0; i < NumPoints; i++)
		{
			if (i == (NumPoints-1))
				succ = 0;
			else
				succ = i+1;

			if ((Pointsy[succ]-Pointsy[i]) != 0)
			{
				Edges[i] = (all_edges *) malloc(sizeof(all_edges));
				Edges[i]->ymin = Mini(Pointsy[i],Pointsy[succ]);
				Edges[i]->ymax = Maxi(Pointsy[i],Pointsy[succ]);

				if (Edges[i]->ymin == Pointsy[i])
					Edges[i]->x=float(Pointsx[i]);
				else
					Edges[i]->x=float(Pointsx[succ]);

				Edges[i]->m = ((float)(Pointsx[succ]-Pointsx[i])) / (Pointsy[succ]-Pointsy[i]);
			}
			else
			{
				Edges[i] = NULL;
			}
		}

		int j,t,m;
		bool found;
		all_edges* Global[MaxPoints];

		for (i = t = 0; i < NumPoints ; i++)
		{
			if (Edges[i] != NULL)
			{
				found = false;
				Global[t] = Edges[i];
				for (j = 0; ((j < t) && (!found)); j++)
				{
					if ((Global[t]->ymin < Global[j]->ymin) || ((Global[t]->ymin == Global[j]->ymin) && (Global[t]->x < Global[j]->x)) || ((Global[t]->ymin == Global[j]->ymin) && (((int)Global[t]->x) == ((int)Global[j]->x)) && (Global[t]->ymax < Global[j]->ymax)))
						found = true;
				}
				if (found)
				{
					all_edges *TempEdges = (all_edges *) malloc(sizeof(all_edges));
					TempEdges->ymin = Global[t]->ymin;
					TempEdges->ymax = Global[t]->ymax;
					TempEdges->x = Global[t]->x;
					TempEdges->m = Global[t]->m;

					for (m = t; m >= j; m--)
					{
						Global[m]->ymin = Global[m-1]->ymin;
						Global[m]->ymax = Global[m-1]->ymax;
						Global[m]->x = Global[m-1]->x;
						Global[m]->m = Global[m-1]->m;
					}

					Global[m]->ymin = TempEdges->ymin;
					Global[m]->ymax = TempEdges->ymax;
					Global[m]->x = TempEdges->x;
					Global[m]->m = TempEdges->m;
					free(TempEdges);
				}
				t++;
			}
		}

		int NumEdges = t;

		if (NumEdges > 0)
		{
			int ScanLine = Global[0]->ymin;
			int MaxScanLine = ScanLine;

			for (i = 1; i < NumEdges; i++)
			{
				if (Global[i]->ymax > MaxScanLine)
					MaxScanLine = Global[i]->ymax;
			}

			int xmin, xmax;
			xmin = xmax = (int)Global[0]->x;

			for (i = 1; i < NumEdges; i++)
			{
				if (Global[i]->x < xmin)
					xmin = (int) Global[i]->x;
				if (Global[i]->x > xmax)
					xmax = (int) Global[i]->x;
			}

			for (i = 0; i < NumPoints; i++)
				Edges[i] = NULL;

			t = 0;
			while ((t<NumEdges) && (Global[t]->ymin == ScanLine))
			{
				Edges[t] = Global[t];
				Global[t] = NULL;
				t++;
			}

			int NumActive = t;

			while (ScanLine < MaxScanLine)
			{
				for (j = 0; j < NumActive; j++)
				{
					if (j != (NumActive-1))
						DrawHLine ((int)(Edges[j]->x),ScanLine, (int)(Edges[j+1]->x)-(int)(Edges[j]->x));
					j++;
				}

				ScanLine++;
				for (j = 0; j < NumActive; j++)
				{
					if (Edges[j]->ymax == ScanLine)
					{
						free(Edges[j]); 
						Edges[j] = NULL;
					}
				}

				for (j = t = 0; j < NumActive; j++)
				{
					if (Edges[j] != NULL)
					{
						if (t != j)
						{
							Edges[t] = Edges[j];
							Edges[j] = NULL;
						}
						t++;
					}
				}

				NumActive = t;

				for(j = 0; j < NumActive; j++)
					Edges[j]->x += Edges[j]->m;

				for(j=0;j<NumEdges;j++)
				{
					if (Global[j] != NULL)
					{
						if (Global[j]->ymin == ScanLine)
						{
							Edges[NumActive] = Global[j];
							Global[j] = NULL;
							NumActive++;
						}
					}
				}

				for (i = 0; i < NumActive; i++)
				{
					found = false;
					for (j = 0;((j < i) && (!found)); j++)
					{
						if ((Edges[i]->x < Edges[j]->x) || ((Edges[i]->x == Edges[j]->x) && (Edges[i]->ymax < Edges[i]->ymax)))
							found = true;
					}
					if (found)
					{
						all_edges *TempEdges = (all_edges *) malloc(sizeof(all_edges));
						TempEdges->ymin = Edges[i]->ymin;
						TempEdges->ymax = Edges[i]->ymax;
						TempEdges->x = Edges[i]->x;
						TempEdges->m = Edges[i]->m;

						for (m = i; m >= j; m--)
						{
							Edges[m]->ymin = Edges[m-1]->ymin;
							Edges[m]->ymax = Edges[m-1]->ymax;
							Edges[m]->x = Edges[m-1]->x;
							Edges[m]->m = Edges[m-1]->m;
						}

						Edges[m]->ymin = TempEdges->ymin;
						Edges[m]->ymax = TempEdges->ymax;
						Edges[m]->x = TempEdges->x;
						Edges[m]->m = TempEdges->m;
						free(TempEdges);
					}
				}
			}
		}
	}
}

class CDrawingQueue
{
	enum
	{
		MAX_TEXTURE = 2,
		MAX_WINDOW  = 3,
	};

public:
	struct TBltParams
	{
		int xDest, yDest;
		flat_experience::ICanvas* ixTex;
		TBound bound;
	};

private:
	TBltParams m_baseProcess[MAX_TEXTURE][WORLDMAP_WSIZE*WORLDMAP_HSIZE*MAX_WINDOW];
	int m_nBaseProcess[MAX_TEXTURE];
	TBltParams m_postProcess[MAX_TEXTURE][WORLDMAP_WSIZE*WORLDMAP_HSIZE*MAX_WINDOW];
	int m_nPostProcess[MAX_TEXTURE];

public:
	CDrawingQueue()
	{
		ClearDP();
	}

	void ClearDP(void)
	{
		memset(m_baseProcess, 0, sizeof(m_baseProcess));
		memset(m_nBaseProcess, 0, sizeof(m_nBaseProcess));
		memset(m_postProcess, 0, sizeof(m_postProcess));
		memset(m_nPostProcess, 0, sizeof(m_nPostProcess));
	}

	void Push(TBltParams& param, int i, int bPostProcess)
	{
		if (bPostProcess)
			m_postProcess[i][m_nPostProcess[i]++] = param;
		else
			m_baseProcess[i][m_nBaseProcess[i]++] = param;
	}

	void Flush(int xOffset, int yOffset)
	{
		int i, j;

		for (j = 0; j < 2; j++)
		for (i = 0; i < m_nBaseProcess[j]; i++)
		{
			TBltParams& BP = m_baseProcess[j][i];
			g_canvas->BitBlt(BP.xDest, BP.yDest, BP.ixTex, BP.bound.x, BP.bound.y, BP.bound.w, BP.bound.h);
		}

		for (j = 0; j < 2; j++)
		for (i = 0; i < m_nPostProcess[j]; i++)
		{
			TBltParams& BP = m_postProcess[j][i];
			g_canvas->BitBlt(BP.xDest, BP.yDest, BP.ixTex, BP.bound.x, BP.bound.y, BP.bound.w, BP.bound.h);
		}

		ClearDP();
	}
};

////////////

class CCoveredMap
{
private:
	CTileMap*     m_pTileMap;
	int           m_xMap, m_yMap;
	unsigned char m_shadowMap[WORLDMAP_WSIZE][WORLDMAP_HSIZE];

	bool m_GetMap(int x, int y)
	{
		if ((x < 0) || (x >= WORLDMAP_WSIZE) || (y < 0) || (y >= WORLDMAP_HSIZE))
			return false;

		return m_pTileMap->IsPassableMap(m_xMap+x, m_yMap+y);
	}

	bool m_SetMap(int x, int y)
	{
		if ((x < 0) || (x >= WORLDMAP_WSIZE) || (y < 0) || (y >= WORLDMAP_HSIZE))
			return false;

		if (m_shadowMap[x][y] != 0)
			return false;

		m_shadowMap[x][y] = 1;
		
		return m_GetMap(x, y);
	}

	void m_ProcessMap(int x, int y)
	{
		if (!m_SetMap(x, y))
			return;

		m_ProcessMap(x+0, y-1);
		m_ProcessMap(x+1, y-1);
		m_ProcessMap(x+1, y+0);
		m_ProcessMap(x+1, y+1);
		m_ProcessMap(x+0, y+1);
		m_ProcessMap(x-1, y+1);
		m_ProcessMap(x-1, y+0);
		m_ProcessMap(x-1, y-1);
	}

	void m_Init()
	{
		const int DIR_ADD_TABLE[8] = {0, 1, 1, 1, 0, -1, -1, -1};

		memset(m_shadowMap, 0, sizeof(m_shadowMap));

		m_ProcessMap(WORLDMAP_XRADIUS, WORLDMAP_YRADIUS);

		if (m_GetMap(WORLDMAP_XRADIUS, WORLDMAP_YRADIUS))
		{
			for (int i = 0; i < 8; i++)
				m_ProcessMap(WORLDMAP_XRADIUS+DIR_ADD_TABLE[i], WORLDMAP_YRADIUS+DIR_ADD_TABLE[(i+6)%8]);
		}
	}

public:
	CCoveredMap(CTileMap* pTileMap, int xMapCenter, int yMapCenter)
		: m_pTileMap(g_p_pdm_res->pTileMap), m_xMap(xMapCenter-WORLDMAP_XRADIUS), m_yMap(yMapCenter-WORLDMAP_YRADIUS) { m_Init(); }

	bool Map(int x, int y)
	{
		if ((x < 0) || (x >= WORLDMAP_WSIZE) || (y < 0) || (y >= WORLDMAP_HSIZE))
			return false;

		return (m_shadowMap[x][y] != 0);
	}

};

CSorakWindowMap::CSorakWindowMap(long x, long y, ISorakChara* pBaseChara)
: CSorakWindow(x, y), m_pBaseChara(pBaseChara)
{
	m_cursor.enable  = false;
	m_shiftKey.state = TShiftKey::SHIFTKEY_NONE;

	m_ChangeState(STATE_MOVE);
}

CSorakWindowMap::~CSorakWindowMap(void)
{
}

int  CSorakWindowMap::m_InRegion(int x, int y)
{
	return CSorakWindow::m_InRegion(x, y);
}

bool CSorakWindowMap::m_Display(long xMapCenter, long yMapCenter)
{
	static CSmSet SetOfForegroundTile("100,102,104..108,110,112,114,118,120,122,124..128,130,132,134,138");
	static CSmSet SetOfForegroundObject("5,11,24,42..45");

	CSorakWindow::m_Display(xMapCenter, yMapCenter);
	
	ISorakChara* m_pChara = (ISorakChara*)m_pBaseChara;

	if (m_pChara)
	{
		xMapCenter = m_pChara->GetX();
		yMapCenter = m_pChara->GetY();

		// ĳͰ ְ focus ̸ ĳ  ǥ
		if (m_IsFocused())
		{
			// item â 
			const TRect winRect = m_GetWindowRect();

//			pAvejVideo->DrawImage(winRect.x2, winRect.y1, 56, winRect.y2 - winRect.y1, g_p_pdm_res->GetImage(2), winRect.x2 - winRect.x1, 0);

			// item 
			int i;
			s_DrawText(winRect.x1+266, 0, "");
			for (i = 0; i < ISorakChara::EQUIPMENT_MAX; i++)
			{
				const TSorakItem& tagItem = m_pChara->GetEquipment(i);
				int ixItem = tagItem.data.ixItem;
				g_canvas->BitBlt(winRect.x1+266+28*(i%2), winRect.y1+27+24*(i/2), g_p_pdm_res->GetImage(CPdmRes::IMAGE_CHARA), 217+24*(ixItem%12), 265+24*(ixItem/12), 24, 24);
			}
			s_DrawText(winRect.x1+266, 100, "");
			for (i = 0; i < ISorakChara::BACKPACK_MAX; i++)
			{
				const TSorakItem&  tagBackPack = m_pChara->GetBackPack(i);
				int ixItem = tagBackPack.data.ixItem;
				g_canvas->BitBlt(winRect.x1+266+28*(i%2), winRect.y1+124+24*(i/2), g_p_pdm_res->GetImage(CPdmRes::IMAGE_CHARA), 217+24*(ixItem%12), 265+24*(ixItem/12), 24, 24);
			}
		}

	}

	int xMapPos = xMapCenter - WORLDMAP_XRADIUS;
	int yMapPos = yMapCenter - WORLDMAP_YRADIUS;

	const TRect clientRect = m_GetClientRect();

	CDrawingQueue::TBltParams bltParam = {0,0,0,0,0,TILE_WSIZE,TILE_HSIZE};
	CDrawingQueue dp;

	CCoveredMap coveredMap(g_p_pdm_res->pTileMap, xMapCenter, yMapCenter);

	for (int y = 0; y < WORLDMAP_HSIZE; y++)
	{
		for (int x = 0; x < WORLDMAP_WSIZE; x++)
		{
			//  ˻
			if ((xMapPos + x < 0) || (yMapPos + y < 0) || (xMapPos + x >= g_p_pdm_res->pTileMap->Width()) || (yMapPos + y >= g_p_pdm_res->pTileMap->Height()))
				continue;

			TMapData mapData = *g_p_pdm_res->pTileMap->Map(xMapPos + x, yMapPos + y);
			bool     isForegroundTile = SetOfForegroundTile.IsSet(mapData.data.tile);

			// ʿ Ⱥ̴ κ̸ 
			if ((!coveredMap.Map(x, y)) && (!(isForegroundTile && coveredMap.Map(x, y+1))))
				continue;

			int xDest = x * TILE_WSIZE;
			int yDest = y * TILE_HSIZE;

			bltParam.xDest = xDest + clientRect.x1;
			bltParam.yDest = yDest + clientRect.y1;
			bltParam.ixTex = g_p_pdm_res->GetImage(CPdmRes::IMAGE_TILE);
			bltParam.bound.x = (mapData.data.tile % 21) * TILE_WPITCH;
			bltParam.bound.y = (mapData.data.tile / 21) * TILE_HPITCH;

			// foreground   ׸ڷ  ׻ ׷ 
			if (isForegroundTile)
			{
				dp.Push(bltParam, 0, true);
				mapData.data.tile = 0;
			}

			// Ϲ Ÿ ׸
			if (mapData.data.tile > 0)
				dp.Push(bltParam, 0, false);

			bltParam.ixTex = g_p_pdm_res->GetImage(CPdmRes::IMAGE_CHARA);

			// Ʈ ׸
			if (mapData.data.object > 0)
			{
				if (mapData.data.object <= 100)
				{
					bltParam.bound.x = (mapData.data.object % 9) * TILE_WPITCH;
					bltParam.bound.y = (mapData.data.object / 9) * TILE_HPITCH + 337;
					dp.Push(bltParam, 1, SetOfForegroundObject.IsSet(mapData.data.object));
				}
				else
				{
					//  Ÿ Ʈ ׸
					mapData.data.object -= 101;
					bltParam.bound.x = (mapData.data.object % 12) * TILE_WPITCH + 217;
					bltParam.bound.y = (mapData.data.object / 12) * TILE_HPITCH + 265;
					dp.Push(bltParam, 1, false);
				}
			}

			// ĳ ׸
			if (mapData.data.character > 0)
			{
//				if (y == 0)
				{
					if (mapData.data.object != 2)
					{
						g_p_pdm_res->pChara[mapData.data.character]->GetFace(bltParam.bound);
						bltParam.yDest = yDest + clientRect.y1 -10;
					}
					else
					{
						// ĳͰ ħ뿡  
						bltParam.yDest = yDest + clientRect.y1 - TILE_HSIZE;
						bltParam.bound.x = (29 % 9) * TILE_WPITCH;
						bltParam.bound.y = (29 / 9) * TILE_HPITCH + 337;
					}

					dp.Push(bltParam, 1, false);
				}
			}
		}
	}

	if (m_cursor.enable)
	{
		TBound& bound = m_cursor.iconRect;

		bltParam.xDest = (m_cursor.xPos - xMapPos) * TILE_WSIZE + clientRect.x1;
		bltParam.yDest = (m_cursor.yPos - yMapPos) * TILE_HSIZE + clientRect.y1 - 10;
		bltParam.bound.x = bound.x;
		bltParam.bound.y = bound.y;
		bltParam.bound.w = bound.w;
		bltParam.bound.h = bound.h;
		bltParam.ixTex = g_p_pdm_res->m_ixImage[1];
		dp.Push(bltParam, 1, true);

		// ó ʿ 
		if (m_cursor.icon == TCursor::ICON_TALK)
		{
			TBound weaponRect = {72+24*8+1, 457-24*4, 24, 24};

			bltParam.bound.x = weaponRect.x;
			bltParam.bound.y = weaponRect.y;
			bltParam.bound.w = weaponRect.w;
			bltParam.bound.h = weaponRect.h;
			dp.Push(bltParam, 1, true);
		}
	}

	dp.Flush(0, 0);

	return true;
}

void  CSorakWindowMap::m_OnMouseDown(EMouseButton button, int shift, int x, int y)
{
}

CSorakWindowMap::TKeyGroup CSorakWindowMap::m_Key2Group(int key)
{
	switch (key)
	{
	case flat_experience::KEY_MENU:
		return KEYGROUP_NONE;
	case flat_experience::KEY_SELECT:
		return KEYGROUP_MENU;
	case flat_experience::KEY_UP:
	case flat_experience::KEY_LEFT:
	case flat_experience::KEY_DOWN:
	case flat_experience::KEY_RIGHT:
		return KEYGROUP_MOVE;
	case flat_experience::KEY_A:
	case flat_experience::KEY_B:
	case flat_experience::KEY_X:
	case flat_experience::KEY_Y:
		return KEYGROUP_CURSOR;
	case flat_experience::KEY_L:
		return KEYGROUP_ENTER;
	case flat_experience::KEY_R:
		return KEYGROUP_CANCEL;
	case flat_experience::KEY_VOLUP:
	case flat_experience::KEY_VOLDOWN:
	default:
		return KEYGROUP_NONE;
	}
}

void CSorakWindowMap::m_StateMove(int shift, int key, TKeyGroup group)
{
	switch (group)
	{
	case KEYGROUP_MOVE:
		{
			int dx = 0;
			int dy = 0;

			switch (key)
			{
				case flat_experience::KEY_UP    : --dy; break;
				case flat_experience::KEY_DOWN  : ++dy; break;
				case flat_experience::KEY_LEFT  : --dx; break;
				case flat_experience::KEY_RIGHT : ++dx; break;
			}

			ISorakChara* m_pChara = (ISorakChara*)m_pBaseChara;

			if ((m_pChara) && ((dx) || (dy)))
			{
				if (shift & TShiftKey::SHIFTKEY_LEFT)
				{
					// push or pull
					m_pChara->Action(CHARAMESSAGE_PUSH, dx, dy);
				}
				else
				{
					// move a person
					m_pChara->Action(CHARAMESSAGE_MOVE, dx, dy);
				}
			}
		}
		break;
	case KEYGROUP_ENTER:
	case KEYGROUP_CANCEL:
		break;
	case KEYGROUP_MENU:
		m_ChangeState(STATE_MENU);
		{
			CSorakWindow* a = CSorakWindow::Create(CSorakWindow::WINDOW_TYPE_MAP, 100, 100, g_p_pdm_res->pChara[MAIN_CHARACTER]);
			a->OnFocus(true);
			assert(false);
		}
		
		break;
	case KEYGROUP_CURSOR:
		m_ChangeState(STATE_CURSOR);
		m_OnKeyDown(0, key);
		break;
	default:
		break;
	}
}

void CSorakWindowMap::m_StateCursor(int shift, int key, TKeyGroup group)
{
	switch (group)
	{
	case KEYGROUP_MOVE:
		m_ChangeState(STATE_MOVE);
		m_OnKeyDown(0, key);
		break;
	case KEYGROUP_ENTER:
		//??  óؾ 
		m_ChangeState(STATE_MOVE);
		break;
	case KEYGROUP_CANCEL:
		m_ChangeState(STATE_MOVE);
		break;
	case KEYGROUP_MENU:
		break;
	case KEYGROUP_CURSOR:
		{
			int dx = 0;
			int dy = 0;

			if (key == flat_experience::KEY_Y)
				--dy;
			if (key == flat_experience::KEY_X)
				++dy;
			if (key == flat_experience::KEY_A)
				--dx;
			if (key == flat_experience::KEY_B)
				++dx;

			ISorakChara* m_pChara = (ISorakChara*)m_pBaseChara;
			assert(m_pChara);

			if ((dx) || (dy))
			{
				if ((abs((m_cursor.xPos + dx) - m_pChara->GetX()) > m_cursor.limit) ||
					(abs((m_cursor.yPos + dy) - m_pChara->GetY()) > m_cursor.limit))
					break;

				m_cursor.xPos += dx;
				m_cursor.yPos += dy;

				// get a person who is beyond the mouse cursor
				int onCharacter = g_p_pdm_res->pTileMap->Map(m_cursor.xPos, m_cursor.yPos)->data.character;
				int onObject    = g_p_pdm_res->pTileMap->Map(m_cursor.xPos, m_cursor.yPos)->data.object;

				// Ŀ ڵ ó

				if (onCharacter > 0)
				{
					m_cursor.SetIcon(TCursor::ICON_TALK);

					// show character's description
					if (onCharacter > MAIN_CHARACTER)
					{
						//??  
						g_p_pdm_res->pChara[onCharacter]->Action(CHARAMESSAGE_TALK, 0, long("SYSCMD_description"));
					}
				}
				else if ((onObject > 0) &&
				    (abs((m_cursor.xPos) - m_pChara->GetX()) <= 1) &&
					(abs((m_cursor.yPos) - m_pChara->GetY()) <= 1))
				{
					m_cursor.SetIcon(TCursor::ICON_GET);
				}
				else
				{
					m_cursor.SetIcon(TCursor::ICON_LOOK);
				}

				//?? m_DisplayCommand();
			}
		}
		break;
	default:
		break;
	}
}

void CSorakWindowMap::m_StateMenu(int shift, int key, TKeyGroup group)
{
	switch (group)
	{
	case KEYGROUP_MOVE:
		//?? ޴ Ű ó
		break;
	case KEYGROUP_ENTER:
	case KEYGROUP_CANCEL:
		m_ChangeState(STATE_MOVE);
		break;
	case KEYGROUP_MENU:
	case KEYGROUP_CURSOR:
		break;
	default:
		break;
	}
}

void CSorakWindowMap::m_ChangeState(TState type)
{
	static TState s_currentState = STATE_NONE;

	// OnStateOut
	switch (s_currentState)
	{
	case STATE_MOVE:
		break;
	case STATE_MENU:
		break;
	case STATE_CURSOR:
		m_cursor.enable = false;
		break;
	default:
		break;
	}

	// OnStateIn
	switch (type)
	{
	case STATE_MOVE:
		m_fnState = &CSorakWindowMap::m_StateMove;
		break;
	case STATE_MENU:
		m_fnState = &CSorakWindowMap::m_StateMenu;
		break;
	case STATE_CURSOR:
		{
			ISorakChara* m_pChara = (ISorakChara*)m_pBaseChara;
			if (m_pChara == NULL)
				return;

			m_cursor.enable = true;
			m_cursor.limit  = 3;
			m_cursor.xPos   = m_pChara->GetX();
			m_cursor.yPos   = m_pChara->GetY();
			m_cursor.SetIcon(TCursor::ICON_LOOK);

			m_fnState       = &CSorakWindowMap::m_StateCursor;
		}
		break;
	default:
		assert(false);
	}

	s_currentState = type;
}

void CSorakWindowMap::m_OnKeyUp(int shift, int key)
{
	// shift key ó
	if (key == flat_experience::KEY_L)
		if (m_shiftKey.state & TShiftKey::SHIFTKEY_LEFT)
			m_shiftKey.state ^= TShiftKey::SHIFTKEY_LEFT;
	if (key == flat_experience::KEY_R)
		if (m_shiftKey.state & TShiftKey::SHIFTKEY_RIGHT)
			m_shiftKey.state ^= TShiftKey::SHIFTKEY_RIGHT;
}

void CSorakWindowMap::m_OnKeyDown(int shift, int key)
{
	// shift key ó
	if (key == flat_experience::KEY_L)
		m_shiftKey.state |= TShiftKey::SHIFTKEY_LEFT;
	if (key == flat_experience::KEY_R)
		m_shiftKey.state |= TShiftKey::SHIFTKEY_RIGHT;

	// state  key ó  б 
	if (m_fnState)
		(this->*m_fnState)(m_shiftKey.state, key, m_Key2Group(key));
}

void CSorakWindowMap::m_OnKeyChar(char ch)
{
}
