
#ifndef __SM_UTIL_H__
#define __SM_UTIL_H__

#include "pixel_format.h"
#include "flat_experience.h"

#if defined(_MSC_VER)
	#include <crtdbg.h>
	//#define new new(_NORMAL_BLOCK, __FILE__, __LINE__)
	#define ENABLE_MEMORY_MANAGER _CrtSetDbgFlag(_CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF)
	#define SET_BREAK_ALLOC(line) _CrtSetBreakAlloc(line)
#else
	#define ENABLE_MEMORY_MANAGER
	#define SET_BREAK_ALLOC(line)
#endif

#if defined(_MSC_VER)
#	define SPRINTF _snprintf
#else
#	define SPRINTF snprintf
#endif


namespace sm_util
{
	flat_experience::ICanvas* CreateCanvasFromPNG(TPixelFormat pixel_format, const unsigned char* p_stream, unsigned int stream_size);
	flat_experience::ICanvas* CreateCanvasFromPNG(TPixelFormat pixel_format, const unsigned char* p_stream, unsigned int stream_size, unsigned long trnasparent_color);
	flat_experience::ICanvas* CreateCanvasFromPNG(TPixelFormat pixel_format, const char* sz_file_name);
	flat_experience::ICanvas* CreateCanvasFromPNG(TPixelFormat pixel_format, const char* sz_file_name, unsigned long trnasparent_color);
}

#endif // #ifndef __SM_UTIL_H__
