
#include "flat_experience.h"

#if defined(_MSC_VER)

#include <windows.h>
#pragma comment(lib, "winmm.lib")

unsigned long flat_experience::system::GetTicks(void)
{
	return timeGetTime();
}

#elif (TARGET_DEVICE == TARGET_GP2XWIZ)

#include <stdlib.h>
#include <sys/time.h>

unsigned long flat_experience::system::GetTicks(void)
{
	static bool    s_is_first = true;
	static timeval s_start_tick;

	if (s_is_first)
	{
		gettimeofday(&s_start_tick, NULL);
		s_is_first = false;
	}

	timeval current_tick;
	gettimeofday(&current_tick, NULL);

	return (current_tick.tv_sec - s_start_tick.tv_sec) * 1000 + (current_tick.tv_usec - s_start_tick.tv_usec) / 1000;
}

#elif (TARGET_DEVICE == TARGET_BADA)

#include <FSystem.h>

unsigned long flat_experience::system::GetTicks(void)
{
	static double s_guide = 0;

	if (s_guide == 0)
	{
		long long tick;
		Osp::System::SystemTime::GetTicks(tick);
		s_guide = tick;
	}

	long long tick;
	Osp::System::SystemTime::GetTicks(tick);
	double current_tick = tick;

	return (unsigned long)((int)(current_tick - s_guide));
}

#else

#error "......."

#endif
